/*************************************************************************

   File:		P2AT.cc

   Author(s):		Ioannis Rekleitis

   Created:		 

   Last Revision:	$Date:  $

   Description:	It contains the robot interface which consist
		of sensors and actuators of the robot.



 ***********************************************************************/

#include "P2AT.h"
#include <iostream>

P2AT::P2AT(const char * host, const int port, const int index):
  rr(host, port + index),
  pp(&rr,0), //position
  lp(&rr,0), //laser
  sp(&rr,0), //sonar
  simp(&rr,0)
{ 
  Id=index;
  cout<<"Robot number:"<<Id<<" created"<<endl;
  rr.Read();
  
  
}



Pose2D P2AT::getPose()
{
   rr.Read();
   return Pose2D(pp.GetXPos(),pp.GetYPos(),pp.GetYaw());
}
void P2AT::setPose(Pose2D nP)
{
  cerr<<"Error P2AT::setPose Not Done Yet!"<<endl;
}
// Motion commands
void P2AT::move(double tVel, double aVel)
{
  pp.SetSpeed(tVel,aVel );
}

void P2AT::setWheelSpeed(double lwVel, double rwVel)
{
  cerr<<"Error P2AT::setWheelSpeed Not Done Yet!"<<endl;
}

void P2AT::translate(double t)
{
  cerr<<"Error P2AT::translate Not Done Yet!"<<endl;
}

void P2AT::absRotate(double a)
{
  cerr<<"Error P2AT::absRotate Not Done Yet!"<<endl;
}

void P2AT::relRotate(double Adegrees)
{
  Pose2D P;
  double Arad=P.d2r(Adegrees);

  // For the Assignment Implement this function to turn the robot by 
  // Adegrees degrees. Remember the pp.GetYaw() returns the orientation 
  // in rad.


 cerr<<"Error P2AT::relRotate Not Done Yet!"<<endl;
}

void P2AT::stop()
{
  pp.SetSpeed(0,0);
}


// Sensing commands
vector<double> P2AT::getLaser()
{
  cerr<<"Error P2AT::getLaser Not Done Yet!"<<endl;
  vector<double> s;
  return(s);

}

vector<double> P2AT::getSonar()
{ 
  //  cout<<"In P2AT::getSonar"<<endl;
  vector<double> s;
  rr.Read();
  for(int i=0; i<sp.GetCount(); i++)
    s.push_back(sp[i]);
  //  cout<<"Vector size: "<<s.size()<<endl;
  return(s);
}


