/*************************************************************************

   File:		Robot.h

   Author(s):		  Ioannis Rekleitis

   Created:		 26/8/09

   Last Revision:	$Date:  $

   Description:	Interface of the Robot class.  Connects to the Player/Stage
                multi-robot simulator.

 ***********************************************************************/

#ifndef ROBOT_H
#define ROBOT_H
using namespace std;

#include <string>
#include "Pose2D.h"
#include <vector>

class Robot
{
 public:
  
  //Robot(); //constructor
  Robot(const char * host, const int port, const int index); //constructor
  virtual ~Robot()=0; //destructor

  Pose2D getPose();
  void setPose(Pose2D nP);

  // Motion commands
  void move(double tVel, double aVel);
  void setWheelSpeed(double lwVel, double rwVel);
  void translate(double t);
  void absRotate(double a);
  void relRotate(double a);
  void stop();

  // Sensing commands
  vector<double> getLaser();
  vector<double> getSonar();



 private:
  int Id;
  string Name;

  
};

#endif	// ROBOT_H
